<?php
/**
 * CGallery
 * @package Joomla!
 * @Copyright (C) 2012 - Yves Hoppe - compojoom.com
 * @All rights reserved
 * @Joomla! is Free Software
 * @Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
 * @version $Revision: 0.9.0 beta $
 **/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

if (!defined('CADDSCRIPT_VERSION_PLUGIN')) {
    define('CADDSCRIPT_VERSION_PLUGIN', '1.0.0');
}

if (!defined('CDEBUG')) {
    define('CDEBUG', false);
}

// import libaries
jimport('joomla.event.plugin');

// Load Helpers
require_once(__DIR__ . '/helper/core.php');

class plgContentCAddScript extends JPlugin {

    private $tag = 'addscript';

    public function onContentPrepare($context, &$article, &$params, $limitstart) {
        // skip plug-in activation when the content is being indexed
        if ($context === 'com_finder.indexer') {
            return;
        }

        $this->parseContent($article);
    }

    public function parseContent($article) {
        if (strpos($article->text, '{'.$this->tag) === false) {
            if(CDEBUG) {
                echo 'Addscript plugin not active in this page';
            }
            return false;  //  gallery not active here
        }

        $doc = JFactory::getDocument();

        // find {addscript}...{/addscript} tags and emit code
        $tag_gallery = preg_quote($this->tag, '#');
        $pattern = '#\{'.$tag_gallery.'([^{}]*)(?<!/)\}(.+?)\{/'.$tag_gallery.'\}#msSu';

        $gallerycount = $this->replaceAllScriptTags($article->text, $pattern);
    }

    public function replaceAllScriptTags(&$text, $pattern) {
        $count = 0;
        $offset = 0;
        while (preg_match($pattern, $text, $match, PREG_OFFSET_CAPTURE, $offset)) {
            $count++;
            $start = $match[0][1];
            $end = $start + strlen($match[0][0]);

            try {
                $body = $this->replaceScriptTag(trim($match[2][0]), trim($match[1][0]));
                $text = substr($text, 0, $start).$body.substr($text, $end);
                $offset = $start + strlen($body);
            } catch (Exception $e) {
                $app = JFactory::getApplication();
                $app->enqueueMessage($e->getMessage(), 'error');
                $offset = $end;
            }
        }

        return $count;
    }

    /**
     * TODO if multiple css or js sources are used put them into one addScript
     * @param $source
     * @param $params
     * @return string
     */
    public function replaceScriptTag($source, $params) {
        if(JDEBUG) {
            $html =  "source: " . $source  . " params: " . $params;
        }

        $doc =& JFactory::getDocument();

        if(preg_match("/javascriptfile/i", $params)) {
            $doc->addScript($source);
        } else if(preg_match("/cssfile/i", $params)) {
            $doc->addStyle($source);
        } else if (preg_match("/javascript/i", $params)) {
            $js = $this->addJavaScript($source, $params);
            $doc->addScriptDeclaration($js);
        } else if (preg_match("/css/i", $params)) {
            $css = $this->addJavaScript($source, $params);
            $doc->addStyleDeclaration($css);
        } else {
            JError::raiseNotice("PLG_CADDSCRIPT_NO_TYPE_DEFINED_FALLING_BACK"); // Fallback
            $js = $this->addJavaScript($source, $params);
            $doc->addScriptDeclaration($js);
        }

        return ""; // We replace the script tags through nothing normally
    }

    /**
     * TODO implement some filter but not sure how <br> tags for example can be wanted, perhaps
     * we should use a parameter in the plugin settings
     * @param $source
     * @param $params
     * @return mixed
     */
    public function addJavaScript($source, $params) {
        return $source;
    }

    /**
     * Filter ?!
     * @param $source
     * @param $params
     * @return mixed
     */
    public function addCSS($source, $params) {
        return $source;
    }

}